﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using System.Net;
using System.Configuration;
using System.Data.SqlClient;
using System.Data;
using System.Linq.Dynamic;
using Syncfusion.JavaScript;
using MvcApplication66.Models;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {

        public ActionResult Index()
        {
            List<string> strings = new List<string> { "1", "2", "testing" };
            string joined = string.Join(",", strings);

            return View();
        }
        //public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        //{
        //    IEnumerable datasource = new MyDbDataContext()._30000Records.ToList();
        //    DataOperations operation = new DataOperations();
        //    if (dm.Where != null)//for filtering
        //        datasource = operation.PerformWhereFilter(datasource, dm.Where, dm.Where[0].Condition);
        //    int count = datasource.AsQueryable().Count();
        //    if (dm.Skip >= 0)//for paging
        //        datasource = operation.PerformSkip(datasource, dm.Skip);
        //    if (dm.Take > 0)//for paging
        //        datasource = operation.PerformTake(datasource, dm.Take);
        //    return Json(new { result = datasource, count = count }, JsonRequestBehavior.AllowGet);
        //}
        public ActionResult DataSource(DataManager dm)
        {
            MyDbDataContext db = new MyDbDataContext();
            var result = db._30000Records.AsQueryable();
            var count = db._30000Records.AsQueryable().Count();
            if (dm.Where != null)
            {
                List<WhereFilter> Where = dm.Where;
                for (var i = 0; i < Where.Count(); i++)
                {
                    if (Where[i].IsComplex)
                    {
                        string cond = Where[i].Condition;
                        string connStr = "", connVal = "";
                        List<WhereFilter> pred = Where[i].predicates;

                        var str = 0;
                        for (var p = 0; p < pred.Count(); p++)
                        {
                            if (pred[p].Operator == "startswith")
                            {
                                connStr = pred[p].Field.ToString() + ".StartsWith(@" + str + ")";
                                connVal = str == 0 ? pred[p].value.ToString() : connVal + " " + cond + " " + pred[p].value.ToString();
                                str++;
                            }
                            else if (pred[p].Operator == "equal")
                            {
                                if (pred[p].value.GetType().Name == "String")
                                {
                                    connStr = str == 0 ? pred[p].Field.ToString() + "=@" + str : connStr + " " + cond + " " + pred[p].Field.ToString() + "=@" + str;
                                    connVal = str == 0 ? pred[p].value.ToString() : connVal + "," + pred[p].value.ToString();
                                    str++;
                                }
                                else
                                {
                                    var privatStr = pred[p].Field.ToString() + " = " + pred[p].value;
                                    connStr = p == 0 ? privatStr : connStr + " " + cond + " " + privatStr;
                                }
                            }
                            else if (pred[p].Operator == "notequal")
                            {
                                if (pred[p].value.GetType().Name == "String")
                                {
                                    connStr = str == 0 ? pred[p].Field.ToString() + "<>@" + str : connStr + " " + cond + " " + pred[p].Field.ToString() + "=@" + str;
                                    connVal = str == 0 ? pred[p].value.ToString() : connVal + "," + pred[p].value.ToString();
                                    str++;
                                }
                                else
                                {
                                    var privatStr = pred[p].Field.ToString() + " <> " + pred[p].value;
                                    connStr = p == 0 ? privatStr : connStr + " " + cond + " " + privatStr;
                                }
                            }
                            else if (pred[p].Operator == "greaterthan")
                            {
                                var privatStr = pred[p].Field.ToString() + " > " + pred[p].value;
                                connStr = p == 0 ? privatStr : connStr + cond + " " + privatStr;
                            }
                            else if (pred[p].Operator == "greaterthanorequal")
                            {
                                var privatStr = pred[p].Field.ToString() + " >= " + pred[p].value;
                                connStr = p == 0 ? privatStr : connStr + " " + cond + " " + privatStr;
                            }
                            else if (pred[p].Operator == "lesserthan")
                            {
                                var privatStr = pred[p].Field.ToString() + " < " + pred[p].value;
                                connStr = p == 0 ? privatStr : connStr + " " + cond + privatStr;
                            }
                            else if (pred[p].Operator == "lesserthanorequal")
                            {
                                var privatStr = pred[p].Field.ToString() + " <= " + pred[p].value;
                                connStr = p == 0 ? privatStr : connStr + " " + cond + privatStr;
                            }
                        }


                        string[] s = connVal.Split(',');
                        if (str > 0) result = result.Where(connStr, s);
                        else result = result.Where(connStr);
                    }
                    else
                    {
                        if (Where[i].Operator == "startswith")
                            result = result.Where(Where[i].Field.ToString() + ".StartsWith(@0)", Where[i].value);
                        else if (Where[i].Operator == "equal")
                        {
                            if (Where[0].value.GetType().Name == "String")
                                result = result.Where(Where[i].Field.ToString() + "=@0", Where[0].value);
                            else
                                result = result.Where(Where[i].Field.ToString() + "=" + Where[0].value);
                        }
                        else if (Where[i].Operator == "notequal") {
                            if (Where[0].value.GetType().Name == "String")
                                result = result.Where(Where[i].Field.ToString() + "<>@0", Where[0].value);
                            else
                                result = result.Where(Where[i].Field.ToString() + "<>" + Where[0].value);
                        }
                        else if (Where[i].Operator == "greaterthan")
                            result = result.Where(Where[i].Field.ToString() + ">" + Where[0].value);
                        else if (Where[i].Operator == "greaterthanorequal")
                            result = result.Where(Where[i].Field.ToString() + ">=" + Where[0].value);
                        else if (Where[i].Operator == "lesserthan")
                            result = result.Where(Where[i].Field.ToString() + "<" + Where[0].value);
                        else if (Where[i].Operator == "lesserthanorequal")
                            result = result.Where(Where[i].Field.ToString() + "<=" + Where[0].value);
                    }
                }
            }
            count = result.AsQueryable().Count();
            //OrderBy must be applied to anyone of the column to apply the skip and take
            result = result.OrderBy("CompanyName").Skip(dm.Skip).Take(dm.Take);
            if (dm.Sorted != null)
            {
                List<Sort> sorted = dm.Sorted;
                string sortText = "";
                for (var i = 0; i < sorted.Count; i++)
                {
                    var str = sorted[i].Name.ToString();
                    if (sorted[i].Direction == "descending")
                        str = str + " desc";
                    sortText = i == 0 ? sortText + str : sortText + "," + str;
                }
                result = result.OrderBy(sortText);
            }
            var list = result.ToList();
            return Json(new { result = list, count = count }, JsonRequestBehavior.AllowGet);
        }
        public ActionResult splitterInGrid()
        {
            var DataSource = OrderRepository.GetAllRecords().ToList();
            ViewBag.data = DataSource;
            return View();
        }
    }
}